// You can import API functions like this from D3.js.
import { select, max, csv, scaleBand, scaleLinear, axisLeft, axisBottom } from 'd3';

const svg = select('svg');

//Affichage de la grandeur de la fenetre
const width = +svg.attr('width');
const height = +svg.attr('height');
//console.log(height);
//console.log(width);

var margin = {
  left: 80,
  top: 10,
  bottom: 100,
  right: 10,
};

//Question 4
const x = scaleBand().range([
  margin.left, 
  width - margin.right - margin.right,
  ]);
var xAx = svg.append('g')
				.attr(
          'transform',
          'translate(' + margin.left + ',0)'
        );

//Question 3
const y = scaleLinear().range([height - margin.bottom, margin.top]);
var yAx = svg.append('g')
				.attr(
          'transform',
          'translate(' + margin.left + ',0)'
        );



//Question 2
const update = (data) => {
  //Question 4
  x.domain(data.map((d) => d.Country));
  xAx.call(d3.axisBottom(x))
      .attr('transform', 'translate(0, 410)')   
      .selectAll("text")  
      .style("text-anchor", "end")
      .attr("dx", "-1em")
      .attr("dy", "-0.5em")
  		.attr("transform", "rotate(-60)");
  
  //Question 3
  y.domain([0, max(data, (d) => + d['2022 Population']), 
              ]);
  yAx.call(d3.axisLeft(y));
  
  //Question 2
  /*svg.selectAll('rect')
    .data(data)
    .enter()
    .append('rect')
    .attr('width', 100)
    .attr('height', 200)*/
  
  //Question 5
  svg.selectAll('rect')
    .data(data)
    .enter()
    .append('rect')
    .attr('x', (d) => x(d.Country))
    .attr('y', (d) => y(+d['2022 Population']))
  	.attr('width', x.bandwidth())
  	.attr(
      'height',
      (d) =>
        height -
        margin.bottom -
        y(d['2022 Population'])
    )
  	//Question 7
    .on("mouseover", function(d){
      var x = d3.event.pageX,
      y = d3.event.pageY;
      d3.select("div.tooltip")
      .style("display", "block")
      .style("left", x + "px")
      .style("top", y + "px")
      .html("Nom : " + d.Country + "<br>" + "Population: " + d['2022 Population'])
    })
    .on("mouseout", function(d){
    	d3.select("div.tooltip").style("display", "none")
		})
  	
  //Question 2 bis
  /*const update = (data) => {
    const g = svg.append('g').attr(
      'transform',
      `translate(${0}, 
    ${0})`
    );
    g.selectAll('rect')
      .data(data)
      .enter()
      .append('rect')
      .attr('width', 100)
      .attr('height', 200);*/
};


//Question 1
csv('data.csv').then((data) => {
  data.forEach((d) => {
    //console.log(d.Country, d['2022 Population']);
  });
  // Suite Question 2
  update(data);
  d3.selectAll('.button_click').on(
    'click',
    function () {
      var buttonID = d3.select(this).attr('id');

      if (buttonID == 'asc') {
        update(
          data.sort(function (a, b) {
            return d3['ascending'](
              +a['2022 Population'],
              +b['2022 Population']
            );
          })
        );
      }

      if (buttonID == 'desc') {
        update(
          data.sort(function (a, b) {
            return d3['descending'](
              +a['2022 Population'],
              +b['2022 Population']
            );
          })
        );
      }
    }
  );
});

//Question 9
/*d3.selectAll(".button_click").on("click", function () {
  if(d3.select(this).attr("id") == "asc")
  {
    console.log("if");
    csv('data.csv').then((data) => {
    data = data.sort(function(a,b) {
            return d3['ascending'](+a['2022 Population'])
    				})
      //...
      update(data);
    });
  }
  if(d3.select(this).attr("id") == "desc")
  {
    
  }

});*/


/*const tridata1 =  (data) => { data.sort(function(a) {
            return d3['descending'](+a.Country)})};*/

//data = data.sort(function(a, b) {
//             return d3['descending'](+a['2022 Population'], 
//                                     +b['2022 Population']);